﻿using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// WHEEL 명령
        /// </summary>
        private RelayCommand wheelCommand;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region WHEEL 명령 - WheelCommand

        /// <summary>
        /// WHEEL 명령
        /// </summary>
        public ICommand WheelCommand
        { 
            get
            {
                return this.wheelCommand ?? (this.wheelCommand = new RelayCommand(ExecuteWheelCommand, CanExecuteWheelCommand));
            }
        }

        #endregion


        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            DataContext = this;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region WHEEL 명령 실행하기 - ExecuteWheelCommand(parameter) 

        /// <summary>
        /// WHEEL 명령 실행하기
        /// </summary>
        /// <param name="parameter">매개 변수</param>
        private void ExecuteWheelCommand(object parameter) 
        {
            MessageBox.Show("마우스 휠을 움직였습니다.");
        }

        #endregion
        #region WHEEL 명령 실행 가능 여부 구하기 - CanExecuteWheelCommand(parameter)

        /// <summary>
        /// WHEEL 명령 실행 가능 여부 구하기
        /// </summary>
        /// <param name="parameter">매개 변수</param>
        /// <returns>WHEEL 실행 가능 여부</returns>
        private bool CanExecuteWheelCommand(object parameter)
        {
            return true;
        }

        #endregion
    }
}